import request from "request-promise-native";
import { Message } from "discord.js";
import { Command, CommandSet, Action, ActionType } from "../model/command";

const rcgRe = /<input id="rcg_image".+value="([^"]+)".*\/>/i;

@CommandSet
export class Rcg {
    @Command({
        pattern: "random comic",
        auth: false,
        documentation: {description: "Generates a comic just for you!", example: "random comic"}
    })
    async randomComic(msg: Message) {
        let result = await request("http://explosm.net/rcg/view/?promo=false");
    
        let regexResult = rcgRe.exec(result);

        msg.channel.send(`${msg.author.toString()} I find this very funny:`, {
            files: [ regexResult[1].trim() ]
        });
    }

    @Action(ActionType.DIRECT_MENTION)
    async testEvent() {
        console.log("asd");
    }
};